

var ERROR_CODE = {
    'success':{'code':0,'msg':'操作成功!'},
    'sql_exception':{'code':1001,'msg':'数据库操作异常!'},
    'net_exception':{'code':1002,'msg':'网络异常!'},
    'exception':{'code':1003,'msg':'系统异常!'},
    'error':{'code':1004,'msg':'接口不存在!'},
    'unauthorized':{'code':1005,'msg':'没有权限!'},
    'bad_request':{'code':1006,'msg':'请求参数有误或缺少参数!'}
}

//function json_p(url){
//    /*var script = document.createElement('script');
//     script.setAttribute("type","text/javascript");
//     script.src = url;
//     document.body.appendChild(script);*/
//    $.ajax({
//        type:'GET',
//        url:url,
//        dataType:'jsonp',
//        async:false,
//        success:function(){
//            alert("success");
//        },
//        error:function(){
//            //alert("系统异常,请稍后再试...");
//        }
//    });
//}
function parseParams(url) {
    url = decodeURIComponent(url);
    //去除链接里的#
    if (url.indexOf("#")){
        var index = url.indexOf("#");
        if (index > 0){
            url = url.substring(0,index);
        }
    }
    
    var params = {};
    var idx = url.indexOf("?");
    if (idx > 0) {
        var queryStr = url.substring(idx + 1);
        if (queryStr.length > 0) {
            var arr = queryStr.split("&");
            for (i = 0; i < arr.length; i++) {
                var pair = arr[i].split("=")
                if (pair.length == 2 && pair[0].length > 0) {
                    params[pair[0]] = pair[1];
                }
            }
        }
    }

    return params;
}
//window.localStorage.getItem('serviceForm1') 转成数组
function parseData(data){
    data = decodeURIComponent(data);
    if (data.length > 0) {
        var params = {};
        var arr = data.split("&");
        for (i = 0; i < arr.length; i++) {
            var pair = arr[i].split("=")
            if (pair.length == 2 && pair[0].length > 0) {
                params[pair[0]] = pair[1];
            }
        }
    }
    return params;
}
//function loadForm(data, tagName) {
//    var tags = $(tagName);
//    var idx = 0;
//    for (; idx < tags.length; idx++) {
//        var name = tags[idx].name;
//        tags[idx].value = data[name]
//    }
//}
//function changeImg(obj, imgId) {
//    $('#' + imgId).val(obj.value);
//}

MyPlatform = {
    /**
     * 弹出dialog
     *
     * @param config  json对象
     * {title : '提示', msg: '确定要执行当前操作吗?', okBtn: '确定', cancelBtn: '取消', ok: function() {}, cancel: function() {}}
     */
    showDialog : function(config) {
        if(typeof config != 'object') {
            config = {title : '提示', msg: '确定要执行当前操作吗?', okBtn: '确定', cancelBtn: '取消', ok: function() {}, cancel: function() {}};
        }
        var title = config.title || "提示";
        var msg = config.msg || "确定要执行当前操作吗";
        var okBtn = config.okBtn || "";
        var cancelBtn = config.cancelBtn || "";
        var hasBtn = (okBtn != "" || cancelBtn != ""),
            idName = config.idname ? config.idname :'';
        var dialog = '<div class="modal fade" tabindex="-1" role="dialog" aria-hidden="true" id="'+ idName +'">' +
            '<div class="modal-dialog modal-sm">' +
            '<div class="modal-content">' +
            '<div class="modal-header">' +
            // '<button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>' +
            '<h4>' + title + '</h4>' +
            '</div>' +
            '<div class="modal-body">' + msg + '</div>' +
            '<div class="modal-footer">' +
            (okBtn != '' ? '<button class="btn btn-primary" data-loading-text="处理中...">' + okBtn + '</button>' : '') +
            (cancelBtn != '' ? '<button class="btn btn-default" data-dismiss="modal" aria-hidden="true">' + cancelBtn + '</button>' : '') +
            (!hasBtn ? '<button class="btn btn-primary" data-dismiss="modal" aria-hidden="true">确定</button>' : '') +
            '</div>' +
            '</div>' +
            '</div>' +
            '</div>';
        var $dialog = $(dialog);
        $dialog.one('show.bs.modal', function() {
            //执行确定的function
            if(okBtn) {
                $(this).off('click', '.modal-footer > .btn:first');
                $(this).on('click', '.modal-footer > .btn:first', function() {
                    $dialog.modal('hide');
                    try {
                        config.ok();
                    } catch(e) {
                        // do something...
                    }
                });
            }
        });
        $dialog.one('hidden.bs.modal', function() {
            $(this).off().find('.btn').off().end().remove();
        });
        $dialog.modal();
    },

    showRemarksDialog : function(config) {

        var modalHtml = '<div class="modal fade" id="myModal" tabindex="-1" role="dialog" aria-hidden="true">' + '<div class="modal-dialog">' + '<div class="modal-content">' + '<div class="modal-header">' + '<button type="button" class="close" data-dismiss="modal" aria-hidden="true">×</button>' + '<h4 class="modal-title">'+config.title+'</h4>' + '</div>' + '<div class="modal-body">' + '<p>' + '<label>'+config.prelabel+'&nbsp;：</label>' + '<textarea class="form-control msgcontent" name="reason" rows="5" required="required" style="height:150px;"></textarea>' + '<span class="nute input-desc" style="margin-left: 170px"></span>' + '</p>' + '</div>' + '<div class="modal-footer">' + '<button type="button" class="btn btn-primary">确定</button>' + '<button type="button" class="btn btn-default" data-dismiss="modal">返回</button>' + '</div>' + '</div>' + '</div>' + '</div>';

        var $modal = $(modalHtml);
        var $reason = $modal.find('[name=reason]');
        var $text = $modal.find('.modal-body .nute');
        $modal.one('show.bs.modal', function() {
            $(this).off('click', '.modal-footer > .btn:first');
            $(this).on('click', '.modal-footer > .btn:first', function() {
                var reason = $reason.val();
                if (reason.length != 0) {
                    config.ok(reason);
                    $modal.modal('hide');
                } else {
                    $text.text('请填写不通过理由!');
                }
            });
        });
        $modal.one('hidden.bs.modal', function() {
            $(this).off().find('.btn').off().end().remove();
        });
        $modal.modal();
    }
}

$.fn.serializeObject = function() {
    var o = {};
    var a = this.serializeArray();
    $.each(a, function() {
        if (o[this.name]) {
            if (!o[this.name].push) {
                o[this.name] = [o[this.name]];
            }
            o[this.name].push(this.value || '');
        } else {
            o[this.name] = this.value || '';
        }
    });

    return o;
}
$.fn.clearForm = function() {
    $(':input','#myform')  
        .not(':button, :submit, :reset, :hidden')  
        .val('')  
        .removeAttr('checked')  
        .removeAttr('selected'); 
}
